﻿B_Radar = {
	screenSize = Vector2(guiGetScreenSize()),
	Map = {},
	fonts = {
		files = {
			{"gfx/fonts/Myriad-Pro.ttf", 10},
			{"gfx/fonts/SignPainter.ttf", 25}
		},
		create = {}
	},
	Blips = {},
	ComponentsHud = {
		"radar",
		"area_name",
		"vehicle_name"
	}
}


	local screenW, screenH = guiGetScreenSize()

addEventHandler("onClientRender", root,
    function()
        dxDrawRectangle(screenW * 0.0078, screenH * 0.6917, screenW * 0.2172, screenH * 0.2630, tocolor(1, 0, 0, 0), false)  -------- opacidade fundo
    end
)

addEventHandler("onClientResourceStart", resourceRoot,
	function ()
		x, y =  (B_Radar.screenSize.x / 1566), (B_Radar.screenSize.y/ 799);
		sW, sH =  (B_Radar.screenSize.x / 1280), (B_Radar.screenSize.y / 720);

		lastVeh = "";
		vehDraw = false;
		vehDrawAlpha = 0;
		vehDrawAlphaBoolean = true;
		vehDrawTime = 0;
		vehDrawTimeI = getTickCount();

		lastCity = "";
		cityDraw = false;
		cityDrawAlpha = 0;
		cityDrawAlphaBoolean = true;
		cityDrawTime = 0;
		cityDrawTimeI = getTickCount();

		PLAYERS_SIZE = 13*sW;
		PLAYERS_ALPHA = 250;

		B_Radar.Map.__index = B_Radar.Map;
		B_Radar.Map.instances = {};
		B_Radar.Map.damageEfect = {};
		B_Radar.Map.radar = B_Radar.Map.new(x*33, y*586, x*305, y*133);  
		B_Radar.Map.radar:setColor(255, 255, 255, 180);		----- cor img do map.png	
		B_Radar.Map.radar:setVisible(true);				
		for i = 1, #B_Radar.fonts.files do
			B_Radar.fonts.create[i] = dxCreateFont(B_Radar.fonts.files[i][1], B_Radar.fonts.files[i][2], B_Radar.fonts.files[i][3] or false);
		end
		
		for k, v in ipairs (Blips) do
			B_Radar.Blips[k] = createBlip(v[1], v[2], v[3], v[4])
			setBlipVisibleDistance(B_Radar.Blips[k], v[5])
		end

		for k, v in ipairs (B_Radar.ComponentsHud) do
			showPlayerHudComponent(v, false);
		end
	end
)

addEventHandler("onClientResourceStop", resourceRoot, 
	function ()
		for k, v in ipairs (B_Radar.ComponentsHud) do
			showPlayerHudComponent(v, true);
		end
	end
)

function math.map(value, low1, high1, low2, high2)
	return low2 + (value - low1) * (high2 - low2) / (high1 - low1);
end

function B_Radar.Map.new(X,Y,W,H)
	local self = setmetatable({}, B_Radar.Map);
	self.x = X;
	self.y = Y;
	self.w = W;
	self.h = H;
	local pos = {getElementPosition(localPlayer)};
	self.posX = pos[1];
	self.posY = pos[2];
	self.posZ = pos[3];
	self.size = 90;
	self.color = {255, 255, 255, 275};
	self.blipSize = x*17;
	self.defaultZoom = 285;
	self.drawRange = self.defaultZoom;
	self.map = dxCreateTexture("gfx/objectsmap/map.png","dxt5");
	self.renderTarget = dxCreateRenderTarget(W, H, true);
	self.shader = dxCreateShader( "shaders/maskTexture.fx" );
	dxSetShaderValue(self.shader, "ScreenTexture", self.renderTarget);
    dxSetShaderValue(self.shader, "MaskTexture", dxCreateTexture("gfx/objectsmap/maskImage.png", "dxt5"));
	self.blips = {};
	for k = 1, 63 do
		self.blips[k] = dxCreateTexture("gfx/icons/"..k..".png","dxt3");
	end
	self.plane = dxCreateTexture("gfx/icons/plane.png","dxt5");
	self.rotation = dxCreateTexture("gfx/icons/rotation.png","dxt5");
	
	addEventHandler("onClientRender", root, B_Radar.Map.render);
	
	table.insert(B_Radar.Map.instances, self);
	return self;
end

function B_Radar.Map:draw()	
	local player = localPlayer;
	local centerX = (self.x) + (self.w/2);
	local centerY = (self.y) + (self.h/2);
	local pr = getPedRotation(player);
	local _, _, camRotZ = getElementRotation(getCamera());	
	self.posX, self.posY, self.posZ = getElementPosition(player);

	local scaleDifference = 100 * getScalingFactorBasedOnSpeed();
	self.drawRange = self.drawRange + scaleDifference;
	local mapSize = 3000 / (self.drawRange/180)
	local mapPosX, mapPosY = -(math.map(self.posX+3000,0,6000,0,mapSize)-self.w/2), -(math.map(-self.posY + 3000, 0, 6000, 0, mapSize)-self.h/2)
		

	local cx,cy,_,tx,ty = getCameraMatrix();
	local north = fRotation(cx,cy,tx,ty);
	dxSetRenderTarget(self.renderTarget, true);
		dxDrawRectangle(0, 0, self.w, self.h,tocolor(0,120,210));
		dxDrawImage(mapPosX, mapPosY, mapSize, mapSize, self.map, north, -mapSize/2 - mapPosX +  self.w/2, -mapSize/2 - mapPosY + self.h/2, tocolor(255,255,255));
		for i, area in ipairs (getElementsByType("radararea")) do
			local ex, ey = getElementPosition(area);
			local w, h = getRadarAreaSize(area);
			local areaX = (3000+ex) / 6000 * mapSize;
			local areaY = (3000-ey) / 6000 * mapSize;
			local scaledW = w / 6000*mapSize;
			local scaledH = -(h / 6000*mapSize);
			areaX = areaX + mapPosX;
			areaY = areaY + mapPosY;
			local rr, gg, bb, alpha = 255,255,255,255;
			rr, gg, bb, alpha = getRadarAreaColor(area);

			if (isRadarAreaFlashing(area)) then
				alpha = alpha*math.abs(getTickCount()%1000-500)/500;
			end
			dxSetBlendMode("modulate_add");
			dxDrawImage(areaX, areaY, scaledW, scaledH,self.blips[1], north, -scaledW/2 - areaX +  self.w/2, -scaledH/2 - areaY + self.h/2,tocolor(rr,gg,bb,alpha));
			dxSetBlendMode("blend");
		end
		if (getPedOccupiedVehicle(localPlayer)) then
			if (getVehicleType(getPedOccupiedVehicle(localPlayer)) == "Plane" or getVehicleType(getPedOccupiedVehicle(localPlayer)) == "Helicopter") then
				local ex, ey, ez = getElementPosition(player);	
				local imgX = ((3000+ex) / 6000 * mapSize) + mapPosX;
				local imgY = ((3000-ey) / 6000 * mapSize) + mapPosY;
				local sizeX, sizeY = dxGetMaterialSize(self.plane);
				dxDrawImage(imgX-sizeX/2, imgY-sizeY/2, sizeX, sizeY,self.plane);
				local rx, ry, rz = getElementRotation(getPedOccupiedVehicle(localPlayer));
				sizeX, sizeY = dxGetMaterialSize(self.rotation);
				dxDrawImage(imgX-sizeX/2, imgY-sizeY/2, sizeX, sizeY, self.rotation,ry);
			end
		end	
	    dxSetRenderTarget()		
	if getElementInterior(player) == 0 then
		dxDrawImage(self.x, self.y, self.w, self.h, self.renderTarget,0,0,0,tocolor(unpack(self.color)))  
	else
		dxDrawImage(self.x, self.y, self.w, self.h, "gfx/objectsmap/lostc.png")
	end		
    dxDrawRectangleBorder(x*30, y*583, x*312, y*140, tocolor(0, 0, 0, 70), 3);--------------------retangulo 
	local rX, rY, rW, rH = self.x + x*5, self.y + y*5, self.w - x * 5, self.h - y * 5;

	local ex, ey = getPointAway(self.posX, self.posY, 0, 5000);
	local blipX, blipY = getRadarFromWorldPosition(ex,ey,rX, rY, rW, rH,mapSize);
	if (blipX < rX) then blipX = rX; end
	if (blipX > rX + rW) then blipX = rX + rW; end
	if (blipY < rY) then blipY = rY; end
	if (blipY > rY + rH) then blipY = rY + rH; end
	dxDrawImage(blipX-self.blipSize/2, blipY-self.blipSize/2, self.blipSize, self.blipSize, self.blips[4], 0, 0, 0, tocolor(255, 255, 255, 255));
	for i, b in ipairs (getElementsByType('blip')) do
		if (getElementDimension(b) == getElementDimension(player) and getElementInterior(b) == getElementInterior(player))then
			local elementAttached =  getElementAttachedTo(b);
			local ex, ey, ez = getElementPosition(b);
			if (getDistanceBetweenPoints2D(ex, ey, self.posX, self.posY) < getBlipVisibleDistance(b)) then
				local blipX, blipY = getRadarFromWorldPosition(ex, ey, rX, rY, rW, rH,mapSize);					
				if (blipX < rX) then blipX = rX; end
				if (blipX > rX + rW) then blipX = rX + rW; end
				if (blipY < rY) then blipY = rY; end
				if (blipY > rY + rH) then blipY = rY + rH ;end
					
				local blipIcon = getBlipIcon(b);
				local rr,gg,bb,aa = 255,255,255,255;
				local blipSize = self.blipSize;

				if (elementAttached and getElementType(elementAttached) == "vehicle") then
					blipSize = blipSize / 2;
					if (#getVehicleOccupants(elementAttached) ~= 0) then
						aa = 0;
					else
						aa = 180;
					end
				end
				if (elementAttached and getElementType(elementAttached) == "player") then
					aa = 0;
				end
				if (blipIcon == 0 or type(blipIcon) == "string") then
					dxDrawImage(blipX-blipSize/2, blipY-blipSize/2, blipSize / 1.5, blipSize / 1.5,"gfx/icons/"..blipIcon..".png", 0,0,0,tocolor(rr,gg,bb,aa))
				else
					dxDrawImage(blipX-blipSize/2, blipY-blipSize/2, blipSize, blipSize, self.blips[blipIcon], 0, 0, 0,tocolor(rr,gg,bb,aa))
				end		
			end
		end
	end

	for i, p in ipairs (getElementsByType('player')) do
		if (getElementDimension(p) == getElementDimension(player) and getElementInterior(p) == getElementInterior(player) and p ~= player) then
			local x, y, z = getElementPosition(p);
			local r, g, b = getPlayerNametagColor(p);
			local er = getPedRotation(p);
			local blipX, blipY = getRadarFromWorldPosition(x, y, rX, rY, rW, rH, mapSize);
			if (blipX < rX) then blipX = rX; end
			if (blipX > rX + rW) then blipX = rX + rW; end
			if (blipY < rY) then blipY = rY; end
			if (blipY > rY + rH) then blipY = rY + rH; end

			if (getPedOccupiedVehicle(p) and getVehicleController(getPedOccupiedVehicle(p)) == p) then
				if (getVehicleType(getPedOccupiedVehicle(p)) == "Helicopter") then
					dxDrawImage(blipX - (PLAYERS_SIZE + 6), blipY - (PLAYERS_SIZE), 30, 30, "gfx/icons/hunter.png", north-er, 0, 0, tocolor(255, 255, 255, PLAYERS_ALPHA+40));
					dxDrawImage(blipX - (PLAYERS_SIZE + 6), blipY - (PLAYERS_SIZE), 30, 30, "gfx/icons/helice.png", getTickCount()%360,0,0, tocolor(r, g, b, PLAYERS_ALPHA));
				elseif (getElementModel(getPedOccupiedVehicle(p)) == 520 or getElementModel(getPedOccupiedVehicle(p)) == 519) then -- Hydra or Shamal
					dxDrawImage(blipX - (PLAYERS_SIZE + 6), blipY - (PLAYERS_SIZE), 20, 20, "gfx/icons/jato.png", north-er, 0, 0, tocolor(255, 255, 255, PLAYERS_ALPHA+40));
				elseif (getElementModel(getPedOccupiedVehicle(p)) == 592 or getElementModel(getPedOccupiedVehicle(p)) == 577 or getElementModel(getPedOccupiedVehicle(p)) == 553) then -- Andromada or AT 400 or Nevada
					dxDrawImage(blipX - (PLAYERS_SIZE + 6), blipY - (PLAYERS_SIZE), 20, 20, "gfx/icons/boing.png", north-er, 0, 0, tocolor(255, 255, 255, PLAYERS_ALPHA+40));
				elseif (getElementModel(getPedOccupiedVehicle(p)) == 511 or getElementModel(getPedOccupiedVehicle(p)) == 512 or getElementModel(getPedOccupiedVehicle(p)) == 593 or getElementModel(getPedOccupiedVehicle(p)) == 460 or getElementModel(getPedOccupiedVehicle(p)) == 513) then
					dxDrawImage(blipX - (PLAYERS_SIZE + 6), blipY - (PLAYERS_SIZE), 20, 20, "gfx/icons/aviao.png", north-er, 0, 0, tocolor(255, 255, 255, 255, 255, 255, PLAYERS_ALPHA+40));
				else
					--dxDrawImage(blipX - PLAYERS_SIZE/2, blipY - PLAYERS_SIZE/2, PLAYERS_SIZE, PLAYERS_SIZE, "gfx/icons/0.png", 0, 0, 0, tocolor(r, g, b, PLAYERS_ALPHA));
				end
			else
				--dxDrawImage(blipX - PLAYERS_SIZE/2, blipY - PLAYERS_SIZE/2, PLAYERS_SIZE, PLAYERS_SIZE, "gfx/icons/0.png", 0, 0, 0, tocolor(r, g, b, PLAYERS_ALPHA));
			end
		end
	end

	local blipX = (3000 + self.posX) / 6000 * mapSize;
	local blipY = (3000 - self.posY) / 6000 * mapSize;
	blipX = blipX + mapPosX + self.x;
	blipY = blipY + mapPosY + self.y;
 
	if (getPedOccupiedVehicle(player) and getVehicleController(getPedOccupiedVehicle(player)) == player) then
		if (getVehicleType(getPedOccupiedVehicle(player)) == "Helicopter") then
			dxDrawImage(blipX - (PLAYERS_SIZE + 2), blipY - (PLAYERS_SIZE + 2), 50, 50, "gfx/icons/hunter.png", north-pr)
			dxDrawImage(blipX - (PLAYERS_SIZE + 2), blipY - (PLAYERS_SIZE + 2), 50, 50, "gfx/icons/helice.png", getTickCount()%360)
		elseif (getElementModel(getPedOccupiedVehicle(player)) == 520 or getElementModel(getPedOccupiedVehicle(player))) == 519 then -- Hydra or Shamal
			dxDrawImage(blipX - (PLAYERS_SIZE + 2), blipY - (PLAYERS_SIZE + 2), 20, 20, "gfx/icons/jato.png", north-pr)
		elseif (getElementModel(getPedOccupiedVehicle(player)) == 592 or getElementModel(getPedOccupiedVehicle(player)) == 577 or getElementModel(getPedOccupiedVehicle(player)) == 553) then -- Andromada or AT 400 or Nevada
			dxDrawImage(blipX - (PLAYERS_SIZE + 2), blipY - (PLAYERS_SIZE + 2), 20, 20, "gfx/icons/boing.png", north-pr)
		elseif (getElementModel(getPedOccupiedVehicle(player)) == 511 or getElementModel(getPedOccupiedVehicle(player)) == 512 or getElementModel(getPedOccupiedVehicle(player)) == 593 or getElementModel(getPedOccupiedVehicle(player)) == 460 or getElementModel(getPedOccupiedVehicle(player)) == 513) then -- Beagle or Cropduster or Dodo or Rustler or Skimmer or StuntPlane
			dxDrawImage(blipX - (PLAYERS_SIZE + 2), blipY - (PLAYERS_SIZE + 2), 20, 20, "gfx/icons/aviao.png", north-pr)
		else
			dxDrawImage(blipX - (PLAYERS_SIZE + 6) / 2, blipY - (PLAYERS_SIZE + 6) / 2, PLAYERS_SIZE + 6, PLAYERS_SIZE + 5 + 2, self.blips[2],north-pr)
		end
	else
		dxDrawImage(blipX - (PLAYERS_SIZE + 6)/2, blipY - (PLAYERS_SIZE + 6 + 2) / 2, PLAYERS_SIZE + 6, PLAYERS_SIZE + 5 + 4, self.blips[2],north-pr)
	end

	for k, v in ipairs(B_Radar.Map.damageEfect) do
		v[3] = v[3] - (getTickCount() - v[1]) / 800; 
		if (v[3] <= 0) then
			table.remove(B_Radar.Map.damageEfect, k);
		else
			dxDrawImage(self.x + 5, self.y + 10, self.w - 5, self.h - 25, "gfx/objectsmap/mapred.png", 0, 0, 0, tocolor(0,0, 0, 0));
		end		
	end	
	drawMoreInformation();
	self:drawVeh();
	self:drawCity();
	self.drawRange = self.defaultZoom;
end

bindKey("F11", "down",
	function ()
		B_Radar.Map.radar:setVisible(not B_Radar.Map.radar.visible);
	end
)